
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>细说 webpack 之流程篇 / iVAN</title>

    <meta name="description" content="细说 webpack 之流程篇 引言 目前,几乎所有业务的开发构建都会用到 webpack .的确,作为模块加载和打包神器,只需配置几个文件,加载各种 loader 就可以享受无痛流程化开发.但对于 webpack 这样一个复杂度较高的插件集合,它的整体流程及思想对我们来说还是很透明的.那么接下来我会带你了解 webpack 这样一个构建黑盒,首先来谈谈它的流程. 准备工作 1. webstorm 中配置 webpack-webstorm-debugger-script 在开始了解之前,必须要能对 webpack 整个流程进行">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">细说 webpack 之流程篇</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmFsaWNkbi5jb20vdGZzL1RCMV9abkhOWFhYWFhYQlhwWFhYWFhYWFhYWC05MDAtNTAwLmpwZw==.jpg"></p>
<h3>引言</h3>
<p>目前，几乎所有业务的开发构建都会用到 webpack 。的确，作为模块加载和打包神器，只需配置几个文件，加载各种 loader 就可以享受无痛流程化开发。但对于 webpack 这样一个复杂度较高的插件集合，它的整体流程及思想对我们来说还是很透明的。那么接下来我会带你了解 webpack 这样一个构建黑盒，首先来谈谈它的流程。</p>
<h3>准备工作</h3>
<h5>1. webstorm 中配置 webpack-webstorm-debugger-script</h5>
<p>在开始了解之前，必须要能对 webpack 整个流程进行 debug ，配置过程比较简单。</p>
<p>先将 <a href="https://www.npmjs.com/package/webpack-webstorm-debugger-script" rel="external nofollow noreferrer">webpack-webstorm-debugger-script</a> 中的 <code>webstorm-debugger.js</code> 置于<code>webpack.config.js</code> 的同一目录下，搭建好你的脚手架后就可以直接 Debug 这个 webstorm-debugger.js 文件了。</p>
<h5>2. webpack.config.js 配置</h5>
<p>估计大家对 webpack.config.js 的配置也尝试过不少次了，这里就大致对这个配置文件进行个分析。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>var path = require('path');var node_modules = path.resolve(__dirname, 'node_modules');var pathToReact = path.resolve(node_modules, 'react/dist/react.min.js');

module.exports = {  // 入口文件，是模块构建的起点，同时每一个入口文件对应最后生成的一个 chunk。  entry: {    bundle: [      'webpack/hot/dev-server',      'webpack-dev-server/client?http://localhost:8080',      path.resolve(__dirname, 'app/app.js')    ]  },  // 文件路径指向(可加快打包过程)。  resolve: {    alias: {      'react': pathToReact    }  },  // 生成文件，是模块构建的终点，包括输出文件与输出路径。  output: {    path: path.resolve(__dirname, 'build'),    filename: '[name].js'  },  // 这里配置了处理各模块的 loader ，包括 css 预处理 loader ，es6 编译 loader，图片处理 loader。  module: {    loaders: [      {        test: /\.js$/,        loader: 'babel',        query: {          presets: ['es2015', 'react']        }      }    ],    noParse: [pathToReact]  },  // webpack 各插件对象，在 webpack 的事件流中执行对应的方法。  plugins: [    new webpack.HotModuleReplacementPlugin()  ]};</pre>
</td>
</tr>
</tbody>
</table>
<p>除此之外再大致介绍下 webpack 的一些核心概念：</p>
<ul>
<li>loader：能转换各类资源，并处理成对应模块的加载器。loader 间可以串行使用。</li>
<li>chunk：code splitting 后的产物，也就是按需加载的分块，装载了不同的 module。</li>
</ul>
<p>对于 module 和 chunk 的关系可以参照 webpack 官方的这张图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2ltZy5hbGljZG4uY29tL3Rwcy9UQjFCMERYTlhYWFhYWGRYRlhYWFhYWFhYWFgtMzY4LTUyMi5qcGc=.jpg"></p>
<ul>
<li>plugin：webpack 的插件实体，这里以 UglifyJsPlugin 为例。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>function UglifyJsPlugin(options) {  this.options = options;}

module.exports = UglifyJsPlugin;

UglifyJsPlugin.prototype.apply = function(compiler) {  compiler.plugin("compilation", function(compilation) {    compilation.plugin("build-module", function(module) {    });    compilation.plugin("optimize-chunk-assets", function(chunks, callback) {      // Uglify 逻辑    });    compilation.plugin("normal-module-loader", function(context) {    });  });};</pre>
</td>
</tr>
</tbody>
</table>
<p>在 webpack 中你经常可以看到 compilation.plugin(‘xxx’, callback) ，你可以把它当作是一个事件的绑定，这些事件在打包时由 webpack 来触发。</li>
</ul>
<h5>3. 流程总览</h5>
<p>在具体流程学习前，可以先通过这幅 <a href="https://img.alicdn.com/tps/TB1GVGFNXXXXXaTapXXXXXXXXXX-4436-4244.jpg" rel="external nofollow noreferrer">webpack 整体流程图</a> 了解一下大致流程（建议保存下来查看）。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2ltZy5hbGljZG4uY29tL3Rwcy9UQjFHVkdGTlhYWFhYYVRhcFhYWFhYWFhYWFgtNDQzNi00MjQ0LmpwZw==.jpg"></p>
<h3>shell 与 config 解析</h3>
<p>每次在命令行输入 webpack 后，操作系统都会去调用 <code>./node_modules/.bin/webpack</code> 这个 shell 脚本。这个脚本会去调用 <code>./node_modules/webpack/bin/webpack.js</code> 并追加输入的参数，如 -p , -w 。(图中 webpack.js 是 webpack 的启动文件，而 $@ 是后缀参数)</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2ltZy5hbGljZG4uY29tL3Rwcy9UQjFrdmZiTlhYWFhYYXJYcFhYWFhYWFhYWFgtNTAwLTExMS5qcGc=.jpg"></p>
<p>在 webpack.js 这个文件中 webpack 通过 optimist 将用户配置的 webpack.config.js 和 shell 脚本传过来的参数整合成 options 对象传到了下一个流程的控制对象中。</p>
<h5>1. optimist</h5>
<p>和 commander 一样，<a href="https://github.com/substack/node-optimist" rel="external nofollow noreferrer">optimist</a> 实现了 node 命令行的解析，其 API 调用非常方便。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>var optimist = require("optimist");

optimist  .boolean("json").alias("json", "j").describe("json")  .boolean("colors").alias("colors", "c").describe("colors")  .boolean("watch").alias("watch", "w").describe("watch")  ...</pre>
</td>
</tr>
</tbody>
</table>
<p>获取到后缀参数后，optimist 分析参数并以键值对的形式把参数对象保存在 optimist.argv 中，来看看 argv 究竟有什么？</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>// webpack --hot -w{  hot: true,  profile: false,  watch: true,  ...}</pre>
</td>
</tr>
</tbody>
</table>
<h5>2. config 合并与插件加载</h5>
<p>在加载插件之前，webpack 将 webpack.config.js 中的各个配置项拷贝到 options 对象中，并加载用户配置在 webpack.config.js 的 plugins 。接着 optimist.argv 会被传入到<code>./node_modules/webpack/bin/convert-argv.js</code> 中，通过判断 argv 中参数的值决定是否去加载对应插件。(至于 webpack 插件运行机制，在之后的运行机制篇会提到)</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>ifBooleanArg("hot", function() {  ensureArray(options, "plugins");  var HotModuleReplacementPlugin = require("../lib/HotModuleReplacementPlugin");  options.plugins.push(new HotModuleReplacementPlugin());});...return options;</pre>
</td>
</tr>
</tbody>
</table>
<p><code>options</code> 作为最后返回结果，包含了之后构建阶段所需的重要信息。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>{   entry: {},//入口配置  output: {}, //输出配置  plugins: [], //插件集合(配置文件 + shell指令)   module: { loaders: [ [Object] ] }, //模块配置  context: //工程路径  ... }</pre>
</td>
</tr>
</tbody>
</table>
<p>这和 webpack.config.js 的配置非常相似，只是多了一些经 shell 传入的插件对象。插件对象一初始化完毕， options 也就传入到了下个流程中。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>var webpack = require("../lib/webpack.js");var compiler = webpack(options);</pre>
</td>
</tr>
</tbody>
</table>
<h3>编译与构建流程</h3>
<p>在加载配置文件和 shell 后缀参数申明的插件，并传入构建信息 options 对象后，开始整个 webpack 打包最漫长的一步。而这个时候，真正的 webpack 对象才刚被初始化，具体的初始化逻辑在 <code>lib/webpack.js</code> 中，如下：</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>function webpack(options) {  var compiler = new Compiler();  ...// 检查options,若watch字段为true,则开启watch线程  return compiler;}...</pre>
</td>
</tr>
</tbody>
</table>
<p>webpack 的实际入口是 Compiler 中的 run 方法，run 一旦执行后，就开始了编译和构建流程 ，其中有几个比较关键的 webpack 事件节点。</p>
<ul>
<li><code>compile</code> 开始编译</li>
<li><code>make</code> 从入口点分析模块及其依赖的模块，创建这些模块对象</li>
<li><code>build-module</code> 构建模块</li>
<li><code>after-compile</code> 完成构建</li>
<li><code>seal</code> 封装构建结果</li>
<li><code>emit</code> 把各个chunk输出到结果文件</li>
<li><code>after-emit</code> 完成输出</li>
</ul>
<h5>1. 核心对象 Compilation</h5>
<p>compiler.run 后首先会触发 compile ，这一步会构建出 Compilation 对象：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2ltZy5hbGljZG4uY29tL3Rwcy9UQjFVZ1M0TlhYWFhYWFpYVlhYWFhYWFhYWFgtNjkzLTk0MC5wbmc=.jpg"></p>
<p>这个对象有两个作用，一是负责组织整个打包过程，包含了每个构建环节及输出环节所对应的方法，可以从图中看到比较关键的步骤，如 <code>addEntry()</code> , <code>_addModuleChain()</code> ,<code>buildModule()</code> , <code>seal()</code> , <code>createChunkAssets()</code> (在每一个节点都会触发 webpack 事件去调用各插件)。二是该对象内部存放着所有 module ，chunk，生成的 asset 以及用来生成最后打包文件的 template 的信息。</p>
<h5>2. 编译与构建主流程</h5>
<p>在创建 module 之前，Compiler 会触发 make，并调用 <code>Compilation.addEntry</code> 方法，通过 options 对象的 entry 字段找到我们的入口js文件。之后，在 addEntry 中调用私有方法<code>_addModuleChain</code> ，这个方法主要做了两件事情。一是根据模块的类型获取对应的模块工厂并创建模块，二是构建模块。</p>
<p>而构建模块作为最耗时的一步，又可细化为三步：</p>
<ul>
<li>调用各 loader 处理模块之间的依赖</p>
<p>webpack 提供的一个很大的便利就是能将所有资源都整合成模块，不仅仅是 js 文件。所以需要一些 loader ，比如 <code>url-loader</code> ， <code>jsx-loader</code> ， <code>css-loader</code> 等等来让我们可以直接在源文件中引用各类资源。webpack 调用 <code>doBuild()</code> ，对每一个 require() 用对应的 loader 进行加工，最后生成一个 js module。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>Compilation.prototype._addModuleChain = function process(context, dependency, onModule, callback) {  var start = this.profile &amp;&amp; +new Date();  ...  // 根据模块的类型获取对应的模块工厂并创建模块  var moduleFactory = this.dependencyFactories.get(dependency.constructor);  ...  moduleFactory.create(context, dependency, function(err, module) {    var result = this.addModule(module);    ...    this.buildModule(module, function(err) {      ...      // 构建模块，添加依赖模块    }.bind(this));  }.bind(this));};</pre>
</td>
</tr>
</tbody>
</table>
</li>
<li>调用 <a href="https://github.com/ternjs/acorn" rel="external nofollow noreferrer">acorn</a> 解析经 loader 处理后的源文件生成抽象语法树 AST<br />
<table>
<tbody>
<tr>
<td></td>
<td>
<pre> Parser.prototype.parse = function parse(source, initialState) {  var ast;  if (!ast) {    // acorn以es6的语法进行解析    ast = acorn.parse(source, {      ranges: true,      locations: true,      ecmaVersion: 6,      sourceType: "module"    });  }  ...};</pre>
</td>
</tr>
</tbody>
</table>
</li>
<li>遍历 AST，构建该模块所依赖的模块
<p>对于当前模块，或许存在着多个依赖模块。当前模块会开辟一个依赖模块的数组，在遍历 AST 时，将 require() 中的模块通过 <code>addDependency()</code> 添加到数组中。当前模块构建完成后，webpack 调用 <code>processModuleDependencies</code> 开始递归处理依赖的 module，接着就会重复之前的构建步骤。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre> Compilation.prototype.addModuleDependencies = function(module, dependencies, bail, cacheGroup, recursive, callback) {  // 根据依赖数组(dependencies)创建依赖模块对象  var factories = [];  for (var i = 0; i &lt; dependencies.length; i++) {    var factory = _this.dependencyFactories.get(dependencies[i][0].constructor);    factories[i] = [factory, dependencies[i]];  }  ...  // 与当前模块构建步骤相同}</pre>
</td>
</tr>
</tbody>
</table>
</li>
</ul>
<h5>3. 构建细节</h5>
<p>module 是 webpack 构建的核心实体，也是所有 module 的 父类，它有几种不同子类：<code>NormalModule</code> , <code>MultiModule</code> , <code>ContextModule</code> , <code>DelegatedModule</code> 等。但这些核心实体都是在构建中都会去调用对应方法，也就是 <code>build()</code> 。来看看其中具体做了什么：</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>// 初始化module信息，如context,id,chunks,dependencies等。NormalModule.prototype.build = function build(options, compilation, resolver, fs, callback) {  this.buildTimestamp = new Date().getTime(); // 构建计时  this.built = true;  return this.doBuild(options, compilation, resolver, fs, function(err) {    // 指定模块引用，不经acorn解析    if (options.module &amp;&amp; options.module.noParse) {      if (Array.isArray(options.module.noParse)) {        if (options.module.noParse.some(function(regExp) {            return typeof regExp === "string" ?            this.request.indexOf(regExp) === 0 :              regExp.test(this.request);          }, this)) {          return callback();        }      } else if (typeof options.module.noParse === "string" ?        this.request.indexOf(options.module.noParse) === 0 :          options.module.noParse.test(this.request)) {        return callback();      }    }    // 由acorn解析生成ast    try {      this.parser.parse(this._source.source(), {        current: this,        module: this,        compilation: compilation,        options: options      });    } catch (e) {      var source = this._source.source();      this._source = null;      return callback(new ModuleParseError(this, source, e));    }    return callback();  }.bind(this));};</pre>
</td>
</tr>
</tbody>
</table>
<p>对于每一个 module ，它都会有这样一个构建方法。当然，它还包括了从构建到输出的一系列的有关 module 生命周期的函数，我们通过 module 父类类图其子类类图(这里以 NormalModule 为例)来观察其真实形态：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2ltZy5hbGljZG4uY29tL3Rwcy9UQjFXT2lSTlhYWFhYY0phWFhYWFhYWFhYWFgtNDQ1LTEyMjgucG5n.jpg"></p>
<p>可以看到无论是构建流程，处理依赖流程，包括后面的封装流程都是与 module 密切相关的。</p>
<h3>打包输出</h3>
<p>在所有模块及其依赖模块 build 完成后，webpack 会监听 <code>seal</code> 事件调用各插件对构建后的结果进行封装，要逐次对每个 module 和 chunk 进行整理，生成编译后的源码，合并，拆分，生成 hash 。 同时这是我们在开发时进行代码优化和功能添加的关键环节。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>Compilation.prototype.seal = function seal(callback) {  this.applyPlugins("seal"); // 触发插件的seal事件  this.preparedChunks.sort(function(a, b) {    if (a.name &lt; b.name) {      return -1;    }    if (a.name &gt; b.name) {      return 1;    }    return 0;  });  this.preparedChunks.forEach(function(preparedChunk) {    var module = preparedChunk.module;    var chunk = this.addChunk(preparedChunk.name, module);    chunk.initial = chunk.entry = true;    // 整理每个Module和chunk，每个chunk对应一个输出文件。    chunk.addModule(module);    module.addChunk(chunk);  }, this);  this.applyPluginsAsync("optimize-tree", this.chunks, this.modules, function(err) {    if (err) {      return callback(err);    }    ... // 触发插件的事件    this.createChunkAssets(); // 生成最终assets    ... // 触发插件的事件  }.bind(this));};</pre>
</td>
</tr>
</tbody>
</table>
<h5>1. 生成最终 assets</h5>
<p>在封装过程中，webpack 会调用 Compilation 中的 <code>createChunkAssets</code> 方法进行打包后代码的生成。 createChunkAssets 流程如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2ltZy5hbGljZG4uY29tL3Rwcy9UQjFjejUuTlhYWFhYYzdYcFhYWFhYWFhYWFgtOTU5LTgwNy5wbmc=.jpg"></p>
<ul>
<li>不同的 Template</p>
<p>从上图可以看出通过判断是入口 js 还是需要异步加载的 js 来选择不同的模板对象进行封装，入口 js 会采用 webpack 事件流的 render 事件来触发 <code>Template类</code> 中的<code>renderChunkModules()</code> (异步加载的 js 会调用 chunkTemplate 中的 render 方法)。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>if(chunk.entry) {  source = this.mainTemplate.render(this.hash, chunk, this.moduleTemplate, this.dependencyTemplates);} else {  source = this.chunkTemplate.render(chunk, this.moduleTemplate, this.dependencyTemplates);}</pre>
</td>
</tr>
</tbody>
</table>
<p>在 webpack 中有四个 Template 的子类，分别是 <code>MainTemplate.js</code> ， <code>ChunkTemplate.js</code>，<code>ModuleTemplate.js</code> ， <code>HotUpdateChunkTemplate.js</code> ，前两者先前已大致有介绍，而 ModuleTemplate 是对所有模块进行一个代码生成，HotUpdateChunkTemplate 是对热替换模块的一个处理。</li>
<li>模块封装
<p>模块在封装的时候和它在构建时一样，都是调用各模块类中的方法。封装通过调用<code>module.source()</code> 来进行各操作，比如说 require() 的替换。</p>
<table>
<tbody>
<tr>
<td></td>
<td>
<pre>MainTemplate.prototype.requireFn = "__webpack_require__";MainTemplate.prototype.render = function(hash, chunk, moduleTemplate, dependencyTemplates) {    var buf = [];    // 每一个module都有一个moduleId,在最后会替换。    buf.push("function " + this.requireFn + "(moduleId) {");    buf.push(this.indent(this.applyPluginsWaterfall("require", "", chunk, hash)));    buf.push("}");    buf.push("");    ... // 其余封装操作};</pre>
</td>
</tr>
</tbody>
</table>
</li>
<li>生成 assets
<p>各模块进行 doBlock 后，把 module 的最终代码循环添加到 source 中。一个 source 对应着一个 asset 对象，该对象保存了单个文件的文件名( name )和最终代码( value )。</li>
</ul>
<h5>2. 输出</h5>
<p>最后一步，webpack 调用 Compiler 中的 <code>emitAssets()</code> ，按照 output 中的配置项将文件输出到了对应的 path 中，从而 webpack 整个打包过程结束。要注意的是，若想对结果进行处理，则需要在 <code>emit</code> 触发后对自定义插件进行扩展。</p>
<h3>总结</h3>
<p>webpack 的整体流程主要还是依赖于 <code>compilation</code> 和 <code>module</code> 这两个对象，但其思想远不止这么简单。最开始也说过，webpack 本质是个插件集合，并且由 <code>tapable</code> 控制各插件在 webpack 事件流上运行，至于具体的思想和细节，将会在后一篇文章中提到。同时，在业务开发中，无论是为了提升构建效率，或是减小打包文件大小，我们都可以通过编写 webpack 插件来进行流程上的控制，这个也会在之后提到。</p>
<p>转载自：http://taobaofed.org/blog/2016/08/24/react-key/</p>
<p>作者：叶斋</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-03 06:26:44</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/react/" title="react">react</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>细说 webpack 之流程篇的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M69ZqWb.html" rel="bookmark">性能测试总结&lpar;二&rpar;---测试流程篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文主要介绍下性能测试的基本流程,性能测试从实际执行层面来看,测试的过程一般分为这么几个阶段,如下图: 下面分别介绍下每个阶段具体需要做什么: 一.性能需求分析: 性能需求分析是整个性能测试工作开展的基础,如果连性能的需求都没弄清楚,后面的性能测试执行其实是没有任何意义的,而且性能需求分析做的好不好直接影响到性能测试的结果. 一些性能测试人员常犯的错误就是测试一开始就直接用工具对系统进行加压,没有弄清楚性能测试的目的,稀里糊涂做完了以后也不知道结果是否满足性能需求.市面上的书籍也大都是直接讲性能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZOkNb.html" rel="bookmark">Android 应用增量升级方案之流程篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者:snowdreamEmail:yanghui1986527#gmail.comGithub: https://github.com/snowdreamQQ 群: 529327615原文地址:https://snowdream.github.io/blog/2016/08/24/android-incremental-update-solutions-flowchart/ 今天,我对Android 应用增量升级方案的流程进行了一个梳理,简单画了一个流程图. 流程图源文件:update.gra			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2Rmvrb.html" rel="bookmark">spark源码分析Master与Worker启动流程篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				spark通信流程 概述 spark作为一套高效的分布式运算框架,但是想要更深入的学习它,就要通过分析spark的源码,不但可以更好的帮助理解spark的工作过程,还可以提高对集群的排错能力,本文主要关注的是Spark的Master的启动流程与Worker启动流程. Master启动 我们启动一个Master是通过Shell命令启动了一个脚本start-master.sh开始的,这个脚本的启动流程如下 start-master.sh -&gt; spark-daemon.sh start org.ap			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgWwVOM.html" rel="bookmark">走向DBA&lbrack;MSSQL篇&rsqb; 针对大表 设计高效的存储过程【原理篇】 附最差性能sql语句进化过程客串</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:走向DBA[MSSQL篇] 针对大表 设计高效的存储过程[原理篇] 附最差性能sql语句进化过程客串 测试的结果在此处 本篇详解一下原理 设计背景 由于历史原因,线上库环境数据量及其庞大,很多千万级以上甚至过亿的表.目标是让N张互相关联的表 按照一张源表为基表,数据搬移归档 这里我们举例N为50 每张表数据5000W 最差性能sql进化客串 2表KeyName 字段意义 名称等相同 从bug01 表中取出前500条不在bug02 表中的数据 最差性能: SELECT TOP 500 a.K			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bad7XQz.html" rel="bookmark">网站设计：复杂产品的响应式设计流程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				都说2013年将是响应式设计爆发的一年.一淘设计团队在去年一淘首页改版时初步尝试了响应式,最近在一淘&quot;玩客&quot;项目中有了更加深入地应用,第一次在复杂产品中实现了全站响应式.中间积累了一些经验也踩了不少坑,于是就有了这个响应式设计三部曲,此系列文章包含理念篇.知识篇和流程篇. 响应式网页不像传统网页只需考虑一种状态,不是交付一套设计稿就完事儿了,它给设计.前端和开发团队之间的协作模式带来新的挑战.在一个复杂产品全面响应式的项目里,交互每个阶段该产出什么?交互与视觉如何协作?前端何时介入?哪			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW2DwXb.html" rel="bookmark">关键CSS和Webpack&colon; 减少阻塞渲染的CSS的自动化解决方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&quot;消除阻塞渲染的CSS和JavaScript&quot;. 这一条Google Page Speed Insights的建议总让我困惑. 当一个网页被访问时,Google希望它仅加载对初始视图有用的内容,并使用空闲时间来加载其他内容.这种方式可以使用户尽可能早地看到页面. 我们可以做很多事情来减少阻塞渲染的JavaScript,例如code splitting.tree shaking,缓存等. 但是如何减少阻塞渲染的CSS?为此,可以拆分并优先加载首次渲染所需要的CSS(关键CSS),然后再加			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZOO86b.html" rel="bookmark">cookie和session的基础知识及在ASP&period;NET中的应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				cookie和session的基础知识: cookie是保存在客户端的,保存少量信息,明文,经常用来保存用户id之类的信息,常见场景就是登录时候的&quot;记住我&quot;.不推荐保存敏感信息. session是会话级的,保存在服务端,每个用户是唯一的,可以用来实现购物车之类的,需要在服务端保存当前用户会话的上下文信息的需求.可以保存在服务器的内存中,不能跨服务器:可以保存在数据库中. 上面是一些零星的知识点.其实还有很多,例如cookie中的sessionid,session还可以用状态服务器保存,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo7NyXb.html" rel="bookmark">happypack 原理解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				说起 happypack 可能很多同学还比较陌生,其实 happypack 是 webpack 的一个插件,目的是通过多进程模型,来加速代码构建,目前我们的线上服务器已经上线这个插件功能,并做了一定适配,效果显著.这里有一些大致参考: 这张图是 happypack 九月逐步全量上线后构建时间的的参考数据,线上构建服务器 16 核环境. 在上这个插件的过程中,我们也发现了这个单人维护的社区插件有一些问题,我们在解决这些问题的同时,也去修改了内部的代码,发布了自己维护的版本 @ali/happypa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXjY2Qb.html" rel="bookmark">高效程序员的45个习惯</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				优秀来自好的习惯.怎样成为优秀的开发人员?图灵公司最近热销的&lt;高效程序员的45个习惯&gt;一书给 出了很好的解答,非常值得一读. 这 本书的英文原版荣获了有软件奥斯卡之称的Jolt生产效率大奖,在Amazon上也是好评如潮.第一作者Venkat Subramaniam博士是Agile Developer公司创始人,敏捷开发方面的权威人士,精通各种开发技术.第二作者Andy Hunt更是大名鼎鼎的人物,是敏捷宣言的创始人,著名图书出版公司Pragmatic Programmers的创始人.他有两本书			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MW7ZrM.html" rel="bookmark" class="title">企业站点如何根据数据分析用户对于内容的需求</a>
					<div>
						对于每一个企业站点来说,为我们的用户和搜索引擎日常提供高质量的内容必做的工作之一,如果一个企业站点来说如果没有坚持更新内容,用户和搜索引擎最终都将会离开你的网站.而对于网站内容的更新,是不是我们只要每 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mv675M.html" rel="bookmark" class="title">我型我塑！用PhotoShop制作个性T恤</a>
					<div>
						你是否想DIY一件与众不同的T恤来体现自己的创意?有了Photoshop,有了一台彩色喷墨打印机,梦想就能轻松实现. 实战1:Photoshop中巧试装 即使你家里没有喷墨打印机,也能在Photosh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apXkXyM.html" rel="bookmark" class="title">译文分享苹果公司工业设计的美学理念</a>
					<div>
						文章描述:(翻译) 苹果美学理念的二分法. 上个礼拜看到的这篇文章虽然用了很多艰深的词,但是作者的看法蛮有意思,所以就翻译过来玩玩,就当是长久不发贴,偶尔来冒个泡吧.照例对原文的翻译没法做到原封不动, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEmmJb.html" rel="bookmark" class="title">Session是否必须依赖Cookie</a>
					<div>
						cookie|session Session是否必须依赖Cookie? www.ouryh.net  银河技术在线║整理时间:2001-8-7║作者: 不详 ║来源: 不详 ║阅读:36 PHP中的s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qba29qM.html" rel="bookmark" class="title">SEO谁都是牛人 论执行力与资源的重要性</a>
					<div>
						这些日子好像大家比较经常谈到的话题就是谁谁谁的哪个关键字的排名用了多么短的时间上去了,悔恨自己的实力为何不如人家,也许有许多是做SEO这个许久的大侠们.用百度一搜,到处都是SEO成功的案例,可是那些东 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9l8gb.html" rel="bookmark" class="title">&period;net的几个重要问题</a>
					<div>
						问题 开门见山,这里是一些入门的问题,我觉得知道这些问题的答案对了解 asp.net 比较有帮助.问题本身不一定严谨,甚至可能不太对,但我想只要对了解 asp.net 有帮助就可以了. 1. Page ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwGnkz.html" rel="bookmark" class="title">利用数据库复制技术实现数据同步更新</a>
					<div>
						复制的概念 复制是将一组数据从一个数据源拷贝到多个数据源的技术,是将一份数据发布到多个存储站点上的有 效方式.使用复制技术,用户可以将一份数据发布到多台服务器上,从而使不同的服务器用户都可以在权 限的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAaBZAM.html" rel="bookmark" class="title">Photoshop制作大气的金色星战标题立体字</a>
					<div>
						  效果字制作分为三个部分:背景.字体效果.装饰.背景使用了一张与主题相关的星空素材,微调了颜色;字体部分用了多个图层,每一层用不同的样式增加描边.浮雕.纹理等;最后加上一些星光装饰即可. 最终效果  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElaWPz.html" rel="bookmark" class="title">8秒恢复操作系统！&OpenCurlyDoubleQuote;救命稻草&rdquo;Pro Magic</a>
					<div>
						  大家是不是遇到过这样的情况,往往在最紧急的时候,病毒却出现并搞得系统崩溃,或平时自己将最重要的文件误删除.今天就是介绍由瓦瑟科技开发,针对这种&quot;要死人&quot;情况的软件解救方案--P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNjA1b.html" rel="bookmark" class="title">mysql双机热备份</a>
					<div>
						mysql从3.23.15版本以后提供数据库复制功能.利用该功能可以实现两个数据库同步,主从模式,互相备份模式的功能. mysql从3.23.15版本以后提供数据库复制功能.利用该功能可以实现两个数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYmjOM.html" rel="bookmark" class="title">Win7系统字体显示比例自定义如何进行更改</a>
					<div>
						  电脑在使用中有时候会发现屏幕显示字体太小或某些文本的显示不协调等问题,这时候就需要对系统字体显示比例相关设置,这样有助于我们阅读屏幕上的内容,那么在w7系统又该如何更改字体显示比例呢?一起来看看w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42rO1M.html" rel="bookmark" class="title">电脑卡顿的原因及解决方法</a>
					<div>
						  电脑卡是什么原因?电脑卡怎么处理?电脑越来越卡的原因这里总结为以下主要几点: 一:电脑中病毒导致电脑越来越卡,有一种攻击可以使网络瘫痪,那就是成千上万次的重复访问!病毒就是这样,大量的在电脑中运行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1E0LxM.html" rel="bookmark" class="title">小工具让U盘使用更安全</a>
					<div>
						  由于U盘的轻巧方便,容易携带,现在越来越多人使用了,但也正由于它的方便携带给我们的数据安全带来了麻烦,试想一下,在你离开电脑的时候别人用U盘把电脑上的重要资料都复制了,如果是重要的机密,这可就麻烦 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEEA4z.html" rel="bookmark" class="title">浅谈Flink批处理优化器之Join优化</a>
					<div>
						跟传统的关系型数据库类似,Flink提供了优化器&quot;hint&quot;(提示)以告诉优化器选择一些执行策略.目前优化提示主要针对批处理中的连接(join).在批处理中共有三个跟连接有关的转换 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamnoPb.html" rel="bookmark" class="title">MySQL &CenterDot; 引擎特性 &CenterDot; InnoDB 文件系统之IO系统和内存管理</a>
					<div>
						综述 在前一篇我们介绍了InnoDB文件系统的物理结构,本篇我们继续介绍InnoDB文件系统的IO接口和内存管理. 为了管理磁盘文件的读写操作,InnoDB设计了一套文件IO操作接口,提供了同步IO和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmR38b.html" rel="bookmark" class="title">一个关于VB&period;NET实现基于rtp、rtcp流媒体传输的问题</a>
					<div>
						问题描述 有谁知道在vb.net2003开发平台上实现C/S模式rtp.rtcp传输协议.请给出相应的代码并做出解析.其他语言或者平台开发的答案就不用发了.谢谢 解决方案 解决方案二: 解决方案三:看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RN2Az.html" rel="bookmark" class="title">微信公众平台-微信查课表如何实现，求大神帮忙</a>
					<div>
						问题描述 微信查课表如何实现,求大神帮忙 最近学校要完善公众平台,想初步做个查课表的功能,该怎么实现呢,教务系统是正方的,外网可以进入 解决方案 教务系统有没有提供webapi接口,如果没有,也可以用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZWEZp.html" rel="bookmark" class="title">Linux cgroup资源隔离各个击破之 - io隔离</a>
					<div>
						Linux Cgroup blkio子系统的用法. blkio子系统支持的两种IO隔离策略 .1. (Completely Fair Queuing 完全公平队列)cfq io调度策略,支持按权重分配 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGE06lM.html" rel="bookmark" class="title">数据不显示-MFC ctrllist控件数据不能显示</a>
					<div>
						问题描述 MFC ctrllist控件数据不能显示 由于数据过多,ctrllist通过滚动条隐藏了部分数据, 当把滚动条拉倒后面,本来有数据的地方看不到数据,双击计入编辑模式后数据有在里面. 求教怎么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Am8Nz.html" rel="bookmark" class="title">上云须知：带你了解一个全面的阿里云</a>
					<div>
						云计算离我们的生活还有多远?其实,云计算一直在你身边. 当你在淘宝天猫购物的时候 当你12306买过年回家的车票的时候 当你闲暇时间刷微博的时候 当你工作用钉钉的时候 当你在优酷看视频的时候 当你在大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RLEnz.html" rel="bookmark" class="title">这个c语言指针为什么不能转换啊，求解释。</a>
					<div>
						问题描述 这个c语言指针为什么不能转换啊,求解释. #include #include typedef int QElemType; typedef int Status; typedef struc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4o76z.html" rel="bookmark" class="title">艾默生发布Liebert eXL，开启UPS 2&period;0时代</a>
					<div>
						ZD至顶网服务器频道 04月20日 新闻消息:  作为全球关键供电设备领先企业,艾默生网络能源4月19日在北京隆重举行了&quot;不妥协的可靠性--Liebert eXL大功率UPS新品发布会&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b221W3b.html" rel="bookmark" class="title">Linux服务器开发之：chmod&lpar;&rpar;函数，chmod命令，以及文件屏蔽umask命令&comma;程序修改umask，详细介绍&plus;案例演示</a>
					<div>
						﻿﻿ 1.依赖的头文件 #include&lt;sys/stat.h&gt; 2.函数定义: //通过传入path中给定的文件名的方式来改变文件制定的权限 int chmod(const char * ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwljmM.html" rel="bookmark" class="title">新版手机淘宝被称微淘，买家可用旺信语音互动</a>
					<div>
						9月22日消息,淘宝手机客户端将作出重大改版,新版手机淘宝被称作&quot;微淘版&quot;,在这个版本中,用户不仅可以文字评论,同时还可加入图片.表情.语音等方式,与卖家进行互动.同时,新版本将着 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44298z.html" rel="bookmark" class="title">城市广告应该是高品位高层次的</a>
					<div>
						http://www.aliyun.com/zixun/aggregation/3640.html&quot;&gt;网友城市天空:8630.html&quot;&gt;有时候走在路上,会看到一些道路 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmgrOp.html" rel="bookmark" class="title">基于Android实现仿QQ5&period;0侧滑&lowbar;Android</a>
					<div>
						本课程将带领大家通过自定义控件实现QQ5.0侧滑菜单,课程将循序渐进,首先实现最普通的侧滑菜单,然后引入属性动画与拖动菜单效果相结合,最终实现QQ5.0侧滑菜单效果.通过本课程大家会对侧滑菜单有更深层 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWqVOz.html" rel="bookmark" class="title">基于jquery实现智能表单验证操作&lowbar;jquery</a>
					<div>
						很多网站的注册模块都可以实现即时检查格式是否正确,这样极大的增强了用户体验,对开发非常有利. 先给大家展示下表单效果图,具体效果如下所示: 1.前台一开始用JQuery实现,先来上HTML标记: &l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNQ76p.html" rel="bookmark" class="title">新浪微博OAuth认证和储存的主要过程详解&lowbar;php实例</a>
					<div>
						网上很多关于OAuth的文章,但是包括sina本身都都没有详细的的介绍,包括验证过程和验证后数据的储存,所以参考了Twitter的认证过程写下一些详细的注释代码. 在我们开始前,我们先建立一张数据库来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrNQOp.html" rel="bookmark" class="title">理解java设计模式之建造者模式&lowbar;java</a>
					<div>
						建造者模式(Builder Pattern)主要用于&quot;分步骤构建一个复杂的对象&quot;,在这其中&quot;分步骤&quot;是一个稳定的算法,而复杂对象的各个部分则经常变化.因此, 建 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYmm6b.html" rel="bookmark" class="title">jquery 显示&ast;天&ast;时&ast;分&ast;秒实现时间计时器&lowbar;jquery</a>
					<div>
						1.用jquery实现时间计时器,从之前的某个时间段到现在距离多少天多少时多少分多少秒? html代码: 复制代码 代码如下: &lt;div id=&quot;times_wrap&quot; cl ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
